package com.ibeetl.admin.core.conf;

import com.google.code.kaptcha.Constants;
import com.google.code.kaptcha.impl.DefaultKaptcha;
import com.google.code.kaptcha.util.Config;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Properties;

@Configuration
public class KaptchaConfig {
    @Bean
    public DefaultKaptcha getDefaultKaptcha(){
        DefaultKaptcha captchaProducer = new DefaultKaptcha();
        Properties properties = new Properties();
        //下面是设置验证码图片的样式 像什么大小、高度、边框、字体大小等等。
        //是否需要外框
        properties.setProperty("kaptcha.border", "yes");
        //框的颜色
        properties.setProperty("kaptcha.border.color", "105,179,90");
        //字体颜色
        properties.setProperty("kaptcha.textproducer.font.color", "blue");
        //渲染效果：水纹：WaterRipple 、鱼眼：FishEyeGimpy 、阴影：ShadowGimpy
         properties.setProperty("kaptcha.obscurificator.impl","com.google.code.kaptcha.impl.ShadowGimpy");
       // 配置⼲扰线 噪点 （只改变最后⼀个单词：NoNoise,DefaultNoise)
        properties.setProperty("kaptcha.noise.impl","com.google.code.kaptcha.impl.DefaultNoise");
        //⼲扰颜⾊，white,black,blue.
        properties.setProperty("kaptcha.noise.color","yellow");
        //设置图片及文字
        properties.setProperty("kaptcha.image.width", "110");
        properties.setProperty("kaptcha.image.height", "40");
        properties.setProperty("kaptcha.textproducer.font.size", "30");

        properties.setProperty("kaptcha.session.key", "code");
        //生成验证码的长度
        properties.setProperty("kaptcha.textproducer.char.length", "4");
        properties.setProperty("kaptcha.textproducer.font.names", "宋体,楷体,微软雅黑");
        //一定要设成自定义实现类的全路径
        properties.setProperty(Constants.KAPTCHA_TEXTPRODUCER_IMPL,
                "com.ibeetl.admin.core.entity.MathExpressionTextCreator");

        //文字间隔
//        properties.setProperty("kaptcha.textproducer.char.space","5");
        //和登录框背景颜⾊⼀致
        //背景颜⾊渐变，开始颜⾊
//        properties.setProperty("kaptcha.background.clear.from","247,247,247");
    //    背景颜⾊渐变，结束颜⾊
//        properties.put("kaptcha.background.clear.to","247,247,247");
//        properties.put("kaptcha.word.impl","com.google.code.kaptcha.text.impl.DefaultWordRenderer");
        Config config = new Config(properties);
        captchaProducer.setConfig(config);
        return captchaProducer;

    }
}
